/*
    Waltress - 100% Broadway Compliant PPC Assembler+Disassembler written in PPC
    Copyright (C) 2022 Vega

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see https://www.gnu.org/licenses/gpl-3.0.txt
*/
	.file	"main.c"
	.machine ppc
	.section	".text"
	.globl __eabi
	.section	.rodata.str1.1,"aMS",@progbits,1
.LC0:
	.string	"\033[2;0H" #Init Cursor
.LC1:
    .string "\x1b[2J" #Reset Cursor, clear current screen contents
.LC2:
    .string "\n\n       /\\      /\\\n      /  \\____/  \\\n     |            |\n     |  @      @  |\n     |___>_**_<___|\n  _______======_______\n (______        ______)\n        |      |\n        |      |        _\n        |      |_______/ |\n        |      |________/\n       / ______ \\\n      / /      \\ \\\n     /_/        \\_\\\n\nWelcome to \x1b[43m\x1b[30mWaltress\x1b[40m\x1b[37m! The PPC Assembler+Disassembler that's entirely handwritten in PPC!\n\nPress \x1b[32mA\x1b[37m on your Controller to Assemble. Press \x1b[31mB\x1b[37m to Disassemble. Press Home/Start button to exit back to \x1b[36mHBC\x1b[37m. For assembling, a file called source.s must be present in the apps/Waltress directory of your SD/USD device. For Disassembling, a file called code.bin must be present.\n\nVersion: 0.2\nCreated by \x1b[35mVega\n\x1b[37mVisit www.MarioKartWii.com for questions or bug reports."
.LC3:
    .string "dbin.bin"
.LC4:
    .string "rb"
.LC5:
    .string "source.s"
.LC6:
    .string "code.bin"
.LC7:
    .string "wb"
.LC8:
    .string "\n\n\x1b[32mSUCCESS!\x1b[37m code.bin has been disassembled. Disassembled contents are in source.s file located at apps/Waltress. Press Home/Start button to exit back to \x1b[36mHBC\x1b[37m."
.LC9:
    .string "abin.bin"
.LC10:
	.string "\n\n\x1b[32mSUCCESS!\x1b[37m source.s has been assembled. Aassembled instructions are in code.bin file located at apps/Waltress. Press Home/Start button to exit back to \x1b[36mHBC\x1b[37m."
.LC11:
    .string "\n\n\x1b[31mError! \x1b[37m%d\n\nPlease read the ERRORS.txt file more information. Press Home/Start button to exit back to \x1b[36mHBC\x1b[37m."
.LC12:
    .string "\n\n\x1b[37mExiting back to \x1b[36mHBC\x1b[37m..."
	.section	.text.startup,"ax",@progbits
	.align 2
	.globl main
	.type	main, @function
main:
.LFB86:
	.cfi_startproc
	stwu 1,-16(1)
	.cfi_def_cfa_offset 16
	mflr 0
	stw 0,20(1)
	stmw 30,8(1)
	.cfi_offset 65, 4
	.cfi_offset 30, -8
	.cfi_offset 31, -4
	bl __eabi
	bl VIDEO_Init
	lis 31,.LANCHOR0@ha
	bl WPAD_Init
	bl PAD_Init #Added in GC controller capabilities!!!
	li 3,0
	bl VIDEO_GetPreferredMode
	la 30,.LANCHOR0@l(31)
	stw 3,.LANCHOR0@l(31)
	bl SYS_AllocateFramebuffer
	lwz 9,.LANCHOR0@l(31)
	li 5,20
	li 4,20
	addis 3,3,0x4000
	lhz 6,4(9)
	lhz 7,8(9)
	slwi 8,6,1
	stw 3,4(30)
	bl CON_Init
	lwz 3,.LANCHOR0@l(31)
	bl VIDEO_Configure
	lwz 3,4(30)
	bl VIDEO_SetNextFramebuffer
	li 3,0
	bl VIDEO_SetBlack
	bl VIDEO_Flush
	bl VIDEO_WaitVSync
	lwz 9,.LANCHOR0@l(31)
	lwz 9,0(9)
	andi. 9,9,0x1
	beq+ 0, launch_app
	bl VIDEO_WaitVSync
	
launch_app:
    #Init the Console Cursor
	lis 3,.LC0@ha
	la 3,.LC0@l(3)
	crxor 6,6,6
	bl printf
	
	#Init FAT System
	bl fatInitDefault
	cmpwi r3, 0
	li r4, -1
	beq- error
	
	#Reset cursor to slightly move its default position
    lis 3,.LC1@ha
	la 3,.LC1@l(3)
	crxor 6,6,6
	bl printf
	
	#Display Main Menu Message
    lis 3,.LC2@ha
	la 3,.LC2@l(3)
	crxor 6,6,6
	bl printf
	
	#Read Controllers
main_menu:
	bl WPAD_ScanPads
	li r3, 0
	bl WPAD_ButtonsDown
	mr r31, r3
	bl PAD_ScanPads
	li r3, 0
	bl PAD_ButtonsDown
	andi. r0, r3, 0x1000 #GCN Start
	bne- leave_to_hbc
	andi. r0, r31, 0x0080 #Wheel/Chuck Home
	bne- leave_to_hbc
	andis. r0, r31, 0x0800 #Classic Home
	bne- leave_to_hbc
	andi. r0, r3, 0x0100 #GCN A
	bne- assemble
	andi. r0, r31, 0x0008 #Wheel/Chuck A
	bne- assemble
	andis. r0, r31, 0x0010 #Classic A
	bne- assemble
	andi. r0, r3, 0x0200 #GCN B
	bne- disassemble
	andi. r0, r31, 0x0004 #Wheel/Chuck B
	bne- disassemble
	andis. r0, r31, 0x0040 #Classic B
	beq+ sync_video #Jump to VIDEO_WaitVSync
	
	#Disassemble!
disassemble:
    #Open dbin.bin, get size, alloc mem for it, dump it, close
    #Open source.s to make sure one doesn't pre-exist
    #Open code.bin, get size, alloc mem for it, dump it, close
    #Alloc mem for new source.s (Size of code.bin x 32)
    #Run dbin.bin engine
    #Create source.s, write to it, close. Print SUCCESS
    
    #Register notes
    #r31 = fp
    #r30 = dbin.bin size
    
    #Reset cursor first
    lis 3,.LC1@ha
	la 3,.LC1@l(3)
	crxor 6,6,6
	bl printf
    
    #Open dbin.bin
    lis 3,.LC3@ha
	la 3,.LC3@l(3)
	lis 4,.LC4@ha
	la 4,.LC4@l(4)
	bl fopen
	mr. r31, r3 #Check & Backup fp
	li r4, -2
	beq- error
	
	#Get size of dbin.bin via fseek and ftell
	li r4, 0
	li r5, 2 #SEEK_END
	bl fseek
	cmpwi r3, 0
	li r4, -3
	bne- error
	mr r3, r31
	bl ftell #No need for error checks
	
	#Rewind to set stream position of file back to the start of file
	#Then allocate memory
	mr r30, r3 #Backup size
	mr r3, r31
	bl rewind #No need for error checks
	li r3, 32 #32-byte alignment
	mr r4, r30 #Size
	bl memalign
	mr. r29, r3 #Check & Backup dbin.bin mem pointer
	li r4, -4
	beq- error
	
	#Dump dbin.bin, then close
	li r4, 1 #size (not real size)
	mr r5, r30 #count (real size of dbin.bin)
	mr r6, r31 #fp
	bl fread
	cmpw r3, r30 #CHECK COUNT, not size
	li r4, -5
	bne- error
	mr r3, r31
	bl fclose
	cmpwi r3, 0
	li r4, -6
    bne- error
	
	#Pre-open source.s, shouldn't exist
	lis 3,.LC5@ha
	la 3,.LC5@l(3)
	lis 4,.LC4@ha
	la 4,.LC4@l(4)
	bl fopen
	cmpwi r3, 0
	li r4, -7
	bne- error #YES THIS IS A BNE! We don't want it to exist
	
	#Open code.bin
	lis 3,.LC6@ha
	la 3,.LC6@l(3)
	lis 4,.LC4@ha
	la 4,.LC4@l(4)
	bl fopen
	mr. r31, r3 #Check & Backup fp
	li r4, -8
	beq- error
	
	#Get size of code.bin via fseek and ftell
	li r4, 0
	li r5, 2 #SEEK_END
	bl fseek
	cmpwi r3, 0
	li r4, -9
	bne- error
	mr r3, r31
	bl ftell #No need for error check
	
	#Rewind to set stream position of file back to the start of file
	#Then allocate memory
	mr r28, r3 #Backup code.bin size
	mr r3, r31
	bl rewind #No need for error checks
	li r3, 32 #32-byte alignment
	mr r4, r28 #Size
	bl memalign
	mr. r27, r3 #Check & Backup code.bin INPUT mem pointer
	li r4, -10
	beq- error
	
	#Dump code.bin, then close
	li r4, 1 #size (not real size)
	mr r5, r28 #count (real size of code.bin)
	mr r6, r31 #fp
	bl fread
	cmpw r3, r28 #CHECK COUNT, not size
	li r4, -11
	bne- error
	mr r3, r31
	bl fclose
	cmpwi r3, 0
	li r4, -12
    bne- error
    
    #Largest instruction in ascii (plus the 0xA byte) possible is psq_lux for a size of 32 bytes.
    #Therefore, take size of code.bin, and mulli by 32 for gen size for new source.s
    slwi r4, r28, 5 #Mulli by 32 aka 0x20
    li r3, 32
    bl memalign
    mr. r31, r3 #Backup pointer to new source.s
    li r4, -13
    beq- error
    
    #Software is required to store sprintf func addr to the reserved lookup table spot in dbin.bin
    lis r0, sprintf@h
    ori r0, r0, sprintf@l
    stw r0, 0x414 (r29)
    
    #fread doesn't do any cache updates btw, we need to do a dcbst and icbi for the entire dbin.bin file
    mr r3, r29 #Pointer of dbin.bin
    mr r4, r30 #Size of dbin.bin
    bl DCStoreRange
    mr r3, r29 #Pointer of dbin.bin
    mr r4, r30 #Size of dbin.bin
    bl ICInvalidateRange
    
#RUN WALTRESS Disassembler (has reserved codes -13 and -14)
#Set pointer where the new source.s will be located
#r31 = Pointer to new source.s r4 arg
#r27 = Pointer to code.bin input r3 arg
#r28 = Pointer to code.bin input size

#Waltress Disassembler Engine
#r3 arg = Instruction to Disassemble
#r4 arg = Pointer to write new Source line to (NOTE nothing is appended by the engine!)

#Setup stuff for d_loop
addi r27, r27, -4 #Updating pointer for r3 arg
addi r30, r31, -1 #Updating pointer for r4 arg, keep r31 intact, will be after D_loop is done
srwi r28, r28, 2 #Divide byte size by 4 to get loop amount aka how many compiled instructions are in the file

#D_loop
D_loop:
lwzu r3, 0x4 (r27) #Load r3 arg
addi r30, r30, 1 #Make sure r30 points past 0xA byte for next source line (ofc if a previous source line was written)
mr r4, r30 #Set dbin.bin r4 arg

mtlr r29
blrl #CALL WALTRESS DISASSEMBLER ENGINE

cmpwi r3, 0
subi r4, r3, 13 #NOTE: Make -1 be -14, make -2 be -15
bne- error

#Decrementer loop, update 'cursor'. Write 0xA (enter new line) after new source line. Cursor will be moved to the new generated 0xA
move_cursor:
lbzu r0, 0x1 (r30) #Since it's impossible for a source line to be just one char long, we don't need an 'addi r30, r30, -1' beforehand!
cmpwi r0, 0 #Check for null byte after newly generated source line
bne+ move_cursor #move 'cursor' to update r23, so when next time DASM runs, r4 arg is correctly updated

#End of source line (also possible end of code.bin file) has been reached, store 0xA. Fyi this will make source.s end by a 0xA byte (ascii for enter-in-new-line) which is perfect because the Assembler follows that format rule
li r0, 0xA
stb r0, 0 (r30)

#Cursor is set, decrement D_loop
subic. r28, r28, 1
bne+ D_loop
    
    #Disassembler completed 100%, create source.s (fopen with write perms)
    lis 3,.LC5@ha
	la 3,.LC5@l(3)
	lis 4,.LC7@ha
	la 4,.LC7@l(4)
	bl fopen
	mr. r29, r3 #Check & Backup fp
	li r4, -16
	beq- error
	
	#Write source.s, then close
	mr r3, r31 #mem pointer to new source.s
	#Calc file size by taking r31 (start of source.s) and subtract it from r30 from D_loop which is the last byte (0xA) address of source.s. After doing the subtraction, add 1 for margin
    subf r31, r31, r30 #Place in a GVR for later r3 return value check
    addi r31, r31, 1 #+1 needed for equation
    li r4, 1 #Size (not real size)
    mr r5, r31 #Count (real size)
	mr r6, r29 #fp
	bl fwrite
	cmpw r3, r31 #CHECK COUNT, not size
	li r4, -17
	bne- error
	mr r3, r29
	bl fclose
	cmpwi r3, 0
	li r4, -18
	bne- error
	
	#SUCCESS
    lis 3,.LC8@ha
	la 3,.LC8@l(3)
	b final_message
	
#==================================================================#


    #Assemble!
assemble:
    #Open abin.bin, get size, alloc mem for it, dump it, close
    #Open code.bin to make sure one doesn't pre-exist
    #Open source.s, get size, alloc mem for it, dump it, close
    #County 0xA bytes to roughly figure out instruction coutn to gen mem size for source.s
    #Alloc mem for new source.s
    #Run abin.bin engine
    #Create code.bin, write to it, close. Print SUCCESS
    
    #Reset cursor first
    lis 3,.LC1@ha
	la 3,.LC1@l(3)
	crxor 6,6,6
	bl printf
    
    #Open abin.bin
    lis 3,.LC9@ha
	la 3,.LC9@l(3)
	lis 4,.LC4@ha
	la 4,.LC4@l(4)
	bl fopen
	mr. r31, r3 #Check & Backup fp
	li r4, -19
	beq- error
	
	#Get size of abin.bin via fseek and ftell
	li r4, 0
	li r5, 2 #SEEK_END
	bl fseek
	cmpwi r3, 0
	li r4, -20
	bne- error
	mr r3, r31
	bl ftell #No need for error check
	
	#Rewind to set stream position of file back to the start of file
	#Then allocate memory
	mr r30, r3 #Backup size, no need for check after ftell
	mr r3, r31
	bl rewind #No need for error check
	li r3, 32 #32-byte alignment
	mr r4, r30 #Size
	bl memalign
	mr. r29, r3 #Check & Backup abin.bin mem pointer
	li r4, -21
	beq- error
	
	#Dump abin.bin, then close
	li r4, 1 #size (not real size)
	mr r5, r30 #count (real size of abin.bin)
	mr r6, r31 #fp
	bl fread
	cmpw r3, r30 #CHECK COUNT, not size
	li r4, -22
	bne- error
	mr r3, r31
	bl fclose
	cmpwi r3, 0
	li r4, -23
    bne- error
	
	#Pre-open code.bin, shouldn't exist
	lis 3,.LC6@ha
	la 3,.LC6@l(3)
	lis 4,.LC4@ha
	la 4,.LC4@l(4)
	bl fopen
	cmpwi r3, 0
	li r4, -24
	bne- error #YES THIS IS A BNE! We don't want it to exist
	
	#Open source.s
	lis 3,.LC5@ha
	la 3,.LC5@l(3)
	lis 4,.LC4@ha
	la 4,.LC4@l(4)
	bl fopen
	mr. r31, r3 #Check & Backup fp
	li r4, -25
	beq- error
	
	#Get size of source.s via fseek and ftell
	li r4, 0
	li r5, 2 #SEEK_END
	bl fseek
	cmpwi r3, 0
	li r4, -26
	bne- error
	mr r3, r31
	bl ftell #No need for error check
	
	#Rewind to set stream position of file back to the start of file
	#Then allocate memory
	mr r28, r3 #Temp Backup size
	mr r3, r31
	bl rewind #No need for error check
	li r3, 32 #32-byte alignment
	mr r4, r28 #Size
	bl memalign
	mr. r27, r3 #Check & Backup source.s input mem pointer
	li r4, -27
	beq- error
	
	#Dump source.s, then close
	li r4, 1 #size (not real size)
	mr r5, r28 #count (real size of source.s)
	mr r6, r31 #fp
	bl fread
	cmpw r3, r28 #CHECK COUNT, not size
	li r4, -28
	bne- error
	mr r3, r31
	bl fclose
	cmpwi r3, 0
	li r4, -29
    bne- error
    
    #Count 0xA bytes in source.s to get code.bin gen size, but just incase, add 4 words of space, hey you never know
    addi r3, r27, -1
    li r4, 0
    pre_gen_codebin_size:
    lbzu r0, 0x1 (r3)
    cmpwi r0, 0
    beq- pre_gen_done
    cmpwi r0, 0xA
    bne+ pre_gen_codebin_size
    addi r4, r4, 4
    b pre_gen_codebin_size
    pre_gen_done:
    addi r4, r4, 16 #Extra 4 words, just in case, the loop read the source.s incorrectly
    #Got size, alloc block for new code.bin
    li r3, 32
    bl memalign
    mr. r31, r3 #Backup new code.bin pointer, r28 no longer needs to be source.s's zie
    li r4, -30
    beq- error
    
    #Software is required to store sscanf and memcmp func addr's to reserved spots in lookup table of abin.bin
    lis r0, sscanf@h
    ori r0, r0, sscanf@l
    lis r3, memcmp@h
    ori r3, r3, memcmp@l
    stw r0, 0x340 (r29)
    stw r3, 0x344 (r29)
    
    #fread doesn't do any cache updates btw, we need to do a dcbst and icbi for the entire abin.bin file
    mr r3, r29 #Pointer
    mr r4, r30 #Size
    bl DCStoreRange
    mr r3, r29 #Pointer
    mr r4, r30 #Size
    bl ICInvalidateRange
    
#RUN WALTRESS ASSEMBLER ENGINE (has reserved codes -31, -32, -33)
#r27 = source.s INPUT pointer aka r3 arg
#r31 = code.bin OUTPUT pointer aka r4 arg

#Waltress Assembler Engine

#r3 arg = Pointer where source line to be disassembled to located at (Engine itself will discard any end-appneded bytes, do not worry)
#r4 arg = Pointer where compiled Instruction will be written to

#Setup stuff for A_loop
#r27; source.s INPUT will be updated thruout loop for the r3 arg
addi r30, r31, -4 #Updating pointer for r4 arg, keep original r31 intact for later use after A_loop is done
li r28, 0 #Use r28 to calc file size for new code.bin

#A_loop
A_loop:
li r4, 0 #Used for counting chars for source line that will soon be sent to the Assembler engine

#Make a temp copy of r27 to r3 (and minus 1 it)
addi r3, r27, -1

#Check for 0xA byte after source line. Source line will SOON be sent to the engine for assembling
count_non0xAchars:
lbzu r0, 0x1 (r3)
addi r4, r4, 1
cmpwi r0, 0xA
beq- prep_asm_engine
cmpwi r0, 0 #Check for EoF
bne+ count_non0xAchars

#No more assembling needs to be done!
b asm_engine_completed

#Found the 0xA byte, cursor is on said 0xA, overwrite 0xA with NULL
prep_asm_engine:
li r0, 0
stb r0, 0 (r3)

#Setup the r3 arg
mr r3, r27

#r27 (r3 arg) pointer must be updated for possible next iteration of calling abin.bin & A_loop
add r27, r27, r4

#Update r4 arg (r30)
addi r30, r30, 4

#Set r4 arg
mr r4, r30

mtlr r29
blrl #CALL WALTRESS Assembler ENGINE :)
cmpwi r3, 0
subi r4, r3, 30 #NOTE: Make -1 turn -31, -2 to -32, -3 to -33
bne- error

#Update generated code.bin size due to successful instruction compilation, repeat loop
addi r28, r28, 4
b A_loop
    
    #Assembler completed 100%, create code.bin (fopen with write perms)
asm_engine_completed:
    lis 3,.LC6@ha
	la 3,.LC6@l(3)
	lis 4,.LC7@ha
	la 4,.LC7@l(4)
	bl fopen
	mr. r29, r3 #Check & Backup fp
	li r4, -34
	beq- error
	
	#Write code.bin, then close
	mr r3, r31 #mem pointer for new code.bin
	li r4, 1 #size (not real size)
	mr r5, r28 #count (real size calc'd from earlier in A_loop)
	mr r6, r29 #fp
	bl fwrite
	cmpw r3, r28 #CHECK COUNT, not size!
	li r4, -35
	bne- error
	mr r3, r29
	bl fclose
	cmpwi r3, 0
	li r4, -36
	bne- error
	
	#SUCCESS
    lis 3,.LC10@ha
	la 3,.LC10@l(3)
	b final_message
	
	#Error handler
error: #r4 already set to error code value
	lis 3,.LC11@ha
	la 3,.LC11@l(3)
	
	#Print out selected error message to Console
final_message: #Doesn't include the leaving HBC message, that one is the real final message
    crxor 6,6,6
	bl printf
app_done:
    bl VIDEO_WaitVSync
	bl WPAD_ScanPads
	li r3, 0
	bl WPAD_ButtonsDown
	mr r31, r3
	bl PAD_ScanPads
	li r3, 0
	bl PAD_ButtonsDown
	andi. r0, r3, 0x1000 #GCN Start
	bne- leave_to_hbc
	andi. r0, r31, 0x0080 #Wheel/Chuck Home
	bne- leave_to_hbc
	andis. r0, r31, 0x0800 #Classic Home
	beq+ app_done
	leave_to_hbc:
	lis 3,.LC1@ha
	la 3,.LC1@l(3)
	crxor 6,6,6
	bl printf
	lis 3,.LC12@ha #Print out "Exiting back to HBC!"
	la 3,.LC12@l(3)
	crxor 6,6,6
	bl printf
	li r3, 0
	bl exit
    
#====================================================================#
	
sync_video:
	bl VIDEO_WaitVSync
	b main_menu
	.cfi_endproc
.LFE86:
	.size	main, .-main
	.section	".bss"
	.align 2
	.set	.LANCHOR0,. + 0
	.type	rmode, @object
	.size	rmode, 4
rmode:
	.zero	4
	.type	xfb, @object
	.size	xfb, 4
xfb:
	.zero	4
	.ident	"GCC: (devkitPPC release 40) 11.2.0"
